; TIP1019.LSP: JOIN.LSP    Join Lines or Arcs   (c)1994, Caodanh Nguyen

(defun C:JOIN (/ OBJ1 OBJ2 GETOBJ1 GETOBJ2 NAME NAME1 NAME2)
   (setvar "cmdecho" 0)
   (setq OBJ1 (entsel "\nPick first LINE or ARC : ")
      GETOBJ1 (entget (car OBJ1))
      NAME1 (cdr (assoc 0 GETOBJ1))
      NAME NAME1
   )
   (while (null (or (= NAME "LINE")(= NAME "ARC")))
      ;; this routine works with LINE or ARC only.
      (setq OBJ1 (entsel
         (strcat "\nYou've picked a " NAME ", please pick LINE or ARC only : "))
         GETOBJ1 (entget (car OBJ1))
         NAME1 (cdr (assoc 0 GETOBJ1))
         NAME NAME1
      )
   )
   (setq OBJ2 (entsel (strcat "\nPick second " NAME1 " : "))
      GETOBJ2 (entget (car OBJ2))
      NAME2 (cdr (assoc 0 GETOBJ2))
      NAME NAME2
   )
   (while (null (= NAME NAME1))
      ;; make sure that the second object is the same name with the first one.
      (setq OBJ2 (entsel (strcat "\nYou've picked a " NAME ", please pick " NAME1 " only : "))
         GETOBJ2 (entget (car OBJ2))
         NAME2 (cdr (assoc 0 GETOBJ2))
         NAME NAME2
      )
   )
   (if (= NAME "LINE")
      (JOINTLINE)
      (JOINTARC)
   )
   (princ)
)
;;
(defun JOINTLINE (/ P1 P2 P3 P4 LETGO D D1 D2 D3 D4 PA PB)
   (setq P1 (cdr (assoc 10 GETOBJ1))
      P2 (cdr (assoc 11 GETOBJ1))
      P3 (cdr (assoc 10 GETOBJ2))
      P4 (cdr (assoc 11 GETOBJ2))
   )
   ;; make sure that the two lines are on the same line
   (if (or (inters P1 P4 P2 P3 nil)(inters P1 P2 P3 P4 nil)
      (inters P1 P3 P2 P4 nil))
      (progn
         (initget 1 "Yes No")
         (setq LETGO (getkword
               (strcat "\nThe two lines are not on the same line. "
         "\nDo you still want to joint them ? (Y/N):")))
      )
      (setq LETGO "Yes")
   )
   (if (= LETGO "Yes")
      (progn
         (setq D1 (distance P1 P3)
            D2 (distance P1 P4)
            D3 (distance P2 P3)
            D4 (distance P2 P4)
            D (max D1 D2 D3 D4)
         )
         (cond
            ((= D1 D)(setq PA P1 PB P3))
            ((= D2 D)(setq PA P1 PB P4))
            ((= D3 D)(setq PA P2 PB P3))
            ((= D4 D)(setq PA P2 PB P4))
         )
         (command ".erase" OBJ2 "")
         (setq GETOBJ1 (subst (cons 10 PA)(assoc 10 GETOBJ1) GETOBJ1)
            GETOBJ1 (subst (cons 11 PB)(assoc 11 GETOBJ1) GETOBJ1)
         )
         (entmod GETOBJ1)
      )
   )
)
;;
(defun JOINTARC (/ PCT1 PCT2 R1 R2 AS1 AE2)
   (setq PCT1 (cdr (assoc 10 GETOBJ1))
      R1 (cdr (assoc 40 GETOBJ1))
      PCT2 (cdr (assoc 10 GETOBJ2))
      R2 (cdr (assoc 40 GETOBJ2))
   )
   (if (and (= (car PCT1)(car PCT2))(= (cadr PCT1)(cadr PCT2))
      (= (caddr PCT1)(caddr PCT2))(= R1 R2))
      (progn
         (setq AS1 (cdr (assoc 50 GETOBJ1))
            AE1 (cdr (assoc 51 GETOBJ1))
            AS2 (cdr (assoc 50 GETOBJ2))
            AE2 (cdr (assoc 51 GETOBJ2))
         )
         (command ".erase" OBJ2 "")
         (if (and (= AS1 AS2)(= AE1 AE2)) ;; one arc picked twice
            (progn
               (command ".erase" OBJ1 "")
               (setq OBJ (list (cons 0 "CIRCLE")(assoc 10 GETOBJ1)
                  (assoc 40 GETOBJ1)(assoc 8 GETOBJ1))
               )
               (if (assoc 62 GETOBJ1)(setq OBJ (append OBJ (list (assoc 62 GETOBJ1)))))
               (if (assoc 6 GETOBJ1)(setq OBJ (append OBJ (list (assoc 6 GETOBJ1)))))
               (entmake OBJ)
            )
            (progn
               (setq GETOBJ1 (subst (cons 50 AS1)(assoc 50 GETOBJ1) GETOBJ1)
                  GETOBJ1 (subst (cons 51 AE2)(assoc 51 GETOBJ1) GETOBJ1)
               )
               (entmod GETOBJ1)
            )
         )
      ) ;; check center point and radius.
      (prompt
      "\nThere are different center points or radii between two arcs, sorry...")
   )
   (princ)
)
;;
(princ); end joint.lsp
